
var FoxTorrent = {
	prefs: null,
	azcomm: null,
	user: "",
	pass: "",

	promptPass: function() {
		this.user = this.azcomm.user;
		this.pass = this.azcomm.pass;
		var win = window.openDialog("chrome://foxtorrent/content/promptpass.xul", "", "chrome,modal", FoxTorrent);
		if (this.user.length > 0)
			this.azcomm.user = this.user;
		if (this.pass.length > 0)
			this.azcomm.pass = this.pass;
		this.user = "";
		this.pass = "";
	},

	startup: function() {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		this.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("foxtorrent.");
		this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this.prefs.addObserver("", this, false);
		this.azcomm = Components.classes['@foxtorrent.mozdev.org/azcomm;1'].getService(Components.interfaces.nsIAzComm);
		if (this.azcomm == null) {
			alert("Could not init AzComm component - check your installation");
			return;
		}
		this.azcomm.host = this.prefs.getCharPref("host");
		this.azcomm.port = this.prefs.getIntPref("port");
		this.azcomm.authenticate = this.prefs.getBoolPref("authenticate");
		if (this.azcomm.authenticate)
			this.promptPass();
		this.init();
	},

	shutdown: function() {
		this.prefs.removeObserver("", this);
	},

	observe: function(subject, topic, data) {
		if (topic != "nsPref:changed")
			return;
		switch (data) {
			case "host":
				this.azcomm.host = this.prefs.getCharPref("host");
				this.init();
				break;
			case "port":
				this.azcomm.port = this.prefs.getIntPref("port");
				this.init();
				break;
			case "authenticate":
				this.azcomm.authenticate = this.prefs.getBoolPref("authenticate");
				if (this.azcomm.authenticate)
					this.promptPass();
				this.init();
				break;
		}
	},

	init: function() {
		this.azcomm.init();
	},

	menuinit: function() {
		var contextMenu=document.getElementById("contentAreaContextMenu");
		contextMenu.addEventListener("popupshowing", FoxTorrent.contextmenu, false);
	},

	contextmenu: function() {
		var ftadd = document.getElementById("context-ftadd");
		if (gContextMenu.onSaveableLink) {
			ftadd.hidden = false;
		} else {
			ftadd.hidden = true;
		}
	},

	addurl: function() {
		if (this.azcomm == null) {
			alert("Could not init AzComm component - check your installation");
			return;
		}
		if (this.azcomm.connected == false) {
			alert("AzComm component could not make connection - check your settings");
			return;
		}
		var url = gContextMenu.getLinkURL();
		if (url.match(/\.torrent$/)) {
			this.azcomm.addURL(url);
		} else {
			alert("Link is not a torrent file");
		}
	}

}

window.addEventListener("load", function(e) {FoxTorrent.startup();}, false);
window.addEventListener("unload", function(e) {FoxTorrent.shutdown();}, false);
